<template>
  <b-row align-v="stretch" class="cardRow">
    <AimsCollapsibleColumn
      :is-collapsed="collapsedList.includes(0)"
      :size="columnSizes[0]"
      :title="$t('availableapplicationprofiles').toString()"
      @isCollapsing="handleCollapse(0)"
    >
      <APSelection
        :selected-application-profile="applicationProfile"
        :session-stored-application-profiles="sessionStoredApplicationProfiles"
        :token="token"
        @emptyApplicationProfile="emptyApplicationProfile"
        @selectApplicationProfile="selectApplicationProfile"
      />
    </AimsCollapsibleColumn>
    <AimsCollapsibleColumn
      :is-collapsed="collapsedList.includes(1)"
      :size="columnSizes[1]"
      :title="
        applicationProfileLabel !== ''
          ? applicationProfileLabel
          : $t('noNameSet').toString()
      "
      @isCollapsing="handleCollapse(1)"
    >
      <graph-layout
        :nodes="nodesLabeled"
        :links="links"
        :active-links="activeLinks"
        :auto-zoom="autoZoom"
        :layout-cfg="layoutCfg"
        @click="switchDisplayedApplicationProfile"
        @link-enter="onLinkEnter"
        @link-out="onLinkOut"
      >
        <template #node="{ node }">
          <article class="text-dark bg-info rounded-lg p-4">
            <h2 class="font-semibold">{{ node.name }}</h2>
            <ul>
              <li v-for="property in node.properties" :key="property.id">
                {{ property.name }}
              </li>
            </ul>
          </article>
        </template>
      </graph-layout>
    </AimsCollapsibleColumn>
  </b-row>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type { Dataset, Quad_Subject } from "@rdfjs/types";

import AimsCollapsibleColumn from "@/components/Layout/AimsCollapsibleColumn.vue";
import GraphLayout from "@/components/Externals/GraphLayout.vue";

import { useColumns } from "@/util/columnSizes";

const defaultColumnSizes = [3, 9];
const growOrder = [1, 0];

import { defineComponent, type PropType } from "vue";
import prefixes from "@zazuko/prefixes/prefixes";
import {
  getApplicationProfileLabelValue,
  getObject,
  parseApplicationProfile,
} from "@/util/linkedData";
import ApplicationProfileImpl from "@/classes/ApplicationProfileImpl";
import factory from "rdf-ext";
import type DatasetExt from "rdf-ext/lib/Dataset";
import serviceProvider from "@/util/service-providers/service-provider";
import useMainStore from "@/store";

export default defineComponent({
  name: "GraphView",
  components: {
    AimsCollapsibleColumn,
    GraphLayout,
  },
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    completeApplicationProfile: {
      required: true,
      type: Object as PropType<{
        definition: Dataset;
        inheritedParts: Record<
          string,
          {
            applicationProfile: ApplicationProfile;
            definition: Dataset;
          }
        >;
      }>,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    sessionStoredApplicationProfiles: {
      required: false,
      default: 0,
      type: Number,
    },
    token: {
      default: "",
      type: String,
    },
  },
  setup() {
    const { collapsedList, columnSizes, handleCollapse } = useColumns(
      defaultColumnSizes,
      growOrder,
      "graph",
    );
    const mainStore = useMainStore();
    return { collapsedList, columnSizes, handleCollapse, mainStore };
  },
  data() {
    return {
      activeLinks: [] as string[],
      autoZoom: true,
      inheritedDataset: factory.dataset() as unknown as DatasetExt,
      layoutCfg: {
        rankdir: "RL",
        align: undefined,
        nodesep: 20,
        ranksep: 50,
        marginx: 10,
        marginy: 10,
      },
    };
  },
  computed: {
    applicationProfileLabel(): string {
      return getApplicationProfileLabelValue(
        this.applicationProfile,
        this.definition,
        this.$i18n.locale,
      );
    },
    completeDefinition(): Dataset {
      let definition = factory.dataset() as unknown as DatasetExt;
      definition = definition.merge(this.inheritedDataset);
      definition = definition.merge(this.completeApplicationProfile.definition);
      return definition as unknown as Dataset;
    },
    links(): {
      source: string;
      target: string;
      sourceProperty: string;
      label: string;
      stroked: boolean;
    }[] {
      return [...this.completeDefinition]
        .filter((quad) => quad.predicate.value === prefixes.owl + "imports")
        .map((quad) => {
          return {
            source: quad.subject.value,
            target: quad.object.value,
            sourceProperty: quad.predicate.value,
            label: quad.predicate.value,
            stroked: !this.completeDefinition.some(
              (otherQuad) =>
                otherQuad.subject.value === quad.subject.value &&
                otherQuad.predicate.value === prefixes.sh + "node" &&
                otherQuad.object.value === quad.object.value,
            ),
          };
        });
    },
    nodesLabeled(): {
      id: string;
      name: string;
      properties?: { id: string; name: string }[];
    }[] {
      return this.nodes.map((node) => {
        return {
          id: node.id,
          name: this.getApplicationProfileLabelByLocale(
            node.id,
            this.completeDefinition,
          ),
          properties: node.properties,
        };
      });
    },
    nodes(): {
      id: string;
      name: string;
      properties?: { id: string; name: string }[];
    }[] {
      const nodes = this.nodeShapes;
      nodes.push(
        ...this.links
          .filter((entry) => !nodes.some((node) => node.id === entry.target))
          .map((entry) => {
            return {
              id: entry.target,
              name: entry.target,
            };
          }),
      );
      return nodes;
    },
    nodeShapes(): {
      id: string;
      name: string;
      properties?: { id: string; name: string }[];
    }[] {
      return [...this.completeDefinition]
        .filter((quad) => quad.object.value === prefixes.sh + "NodeShape")
        .map((quad) => {
          const propertyObjects = new Set(
            [...this.completeDefinition]
              .filter(
                (filterQuad) =>
                  filterQuad.subject.value === quad.subject.value &&
                  filterQuad.predicate.value === prefixes.sh + "property",
              )
              .map((temporaryQuad) => temporaryQuad.object.value),
          );

          return {
            id: quad.subject.value,
            name: quad.subject.value,
            properties: [...this.completeDefinition]
              .filter(
                (quad) =>
                  quad.predicate.value === prefixes.sh + "path" &&
                  propertyObjects.has(quad.subject.value) &&
                  quad.object.value !== prefixes.rdf + "type",
              )
              .map((quad) => {
                return {
                  id: quad.object.value,
                  name: this.getEntryLabel(
                    quad.subject,
                    this.completeDefinition,
                    quad.object.value,
                  ),
                };
              }),
          };
        });
    },
  },
  watch: {
    async applicationProfile() {
      this.inheritedDataset = factory.dataset() as unknown as DatasetExt;
      await this.getInheritedParts();
    },
  },
  async mounted() {
    await this.getInheritedParts();
  },
  methods: {
    emptyApplicationProfile() {
      this.$emit("emptyApplicationProfile");
    },
    async getApplicationProfile(
      baseUrl: string,
      accessToken?: string | null,
    ): Promise<ApplicationProfile> {
      try {
        return await serviceProvider.apiConnection.getApplicationProfile(
          baseUrl,
          accessToken,
        );
      } catch {
        return this.mainStore.getApplicationProfile(baseUrl);
      }
    },
    getApplicationProfileLabelByLocale(
      applicationProfileUrl: string,
      definition: Dataset,
    ): string {
      const applicationProfile = new ApplicationProfileImpl(
        applicationProfileUrl,
        applicationProfileUrl,
      );
      return getApplicationProfileLabelValue(
        applicationProfile,
        definition,
        this.$i18n.locale,
      );
    },
    getEntryLabel(
      entry: Quad_Subject,
      definition: Dataset,
      defaultValue: string,
    ): string {
      const localeObject = getObject(
        entry,
        factory.namedNode(prefixes.sh + "name"),
        definition,
        this.$i18n.locale,
      );
      if (localeObject.length > 0) {
        return localeObject[0].object.value;
      }
      // If no name is present, return the entry to render the path url
      return defaultValue;
    },
    async getInheritedParts() {
      if (
        this.inheritedDataset.size === 0 &&
        this.applicationProfile.inheritedFrom
      ) {
        for (const inheritedFrom of this.applicationProfile.inheritedFrom) {
          const inheritedAP = await this.getApplicationProfile(inheritedFrom);
          const definitionOfInheritedAp =
            await parseApplicationProfile(inheritedAP);
          const matchList = [
            ...definitionOfInheritedAp.match(
              null,
              factory.namedNode(prefixes.owl + "imports"),
            ),
          ];
          for (const entry of matchList) {
            if (entry.object.value !== this.applicationProfile.base_url) {
              definitionOfInheritedAp.delete(entry);
            }
          }
          this.inheritedDataset = this.inheritedDataset.merge(
            definitionOfInheritedAp as unknown as DatasetExt,
          );
        }
      }
    },
    onLinkEnter(link: string) {
      this.activeLinks = [link];
    },
    onLinkOut() {
      this.activeLinks = [];
    },
    selectApplicationProfile(selectedApplicationProfile: ApplicationProfile) {
      this.$emit("selectApplicationProfile", selectedApplicationProfile);
    },
    switchDisplayedApplicationProfile(baseUrl: string) {
      this.$emit("switchDisplayedApplicationProfile", baseUrl);
    },
  },
});
</script>

<style>
@tailwind base;
@tailwind components;
@tailwind utilities;

@layer base {
  :root {
    --color-primary-50: #f0f9ff;
    --color-primary-100: #e0f2fe;
    --color-primary-200: #bae6fd;
    --color-primary-300: #7dd3fc;
    --color-primary-400: #38bdf8;
    --color-primary-500: #0ea5e9;
    --color-primary-600: #0284c7;
    --color-primary-700: #0369a1;
    --color-primary-800: #075985;
    --color-primary-900: #0c4a6e;

    font-size: 14px;
    line-height: 20px;
  }

  html,
  body,
  #app {
    height: 100%;
    width: 100%;
  }
}
</style>
